searchNodes=[{"doc":"Simple + Powerful interface to the Erlang Mnesia Database. See the README to get started.","ref":"GSMLG.Mnesia.html","title":"GSMLG.Mnesia","type":"module"},{"doc":"Tells GSMLG.Mnesia about other nodes running GSMLG.Mnesia/Mnesia. You can use this to connect to and synchronize with other nodes at runtime and/or on discovery, to take full advantage of the distribution mode of GSMLG.Mnesia and Mnesia. This is a wrapper method around :mnesia.change_config/2 . Example # Connect to GSMLG.Mnesia running on a specific node GSMLG.Mnesia . add_nodes ( :node_xyz@some_host ) # Add all connected nodes to GSMLG.Mnesia distributed database GSMLG.Mnesia . add_nodes ( Node . list ( ) )","ref":"GSMLG.Mnesia.html#add_nodes/1","title":"GSMLG.Mnesia.add_nodes/1","type":"function"},{"doc":"Prints :mnesia information to console.","ref":"GSMLG.Mnesia.html#info/0","title":"GSMLG.Mnesia.info/0","type":"function"},{"doc":"Start the GSMLG.Mnesia Application. This starts GSMLG.Mnesia and :mnesia along with some sane application defaults. See :mnesia.start/0 for more details.","ref":"GSMLG.Mnesia.html#start/0","title":"GSMLG.Mnesia.start/0","type":"function"},{"doc":"Stop the GSMLG.Mnesia Application.","ref":"GSMLG.Mnesia.html#stop/0","title":"GSMLG.Mnesia.stop/0","type":"function"},{"doc":"Returns all information about the Mnesia system. Optionally accepts a key atom argument which returns result for only that key. Will throw an exception if that key is invalid. See :mnesia.system_info/0 for more information and a full list of allowed keys.","ref":"GSMLG.Mnesia.html#system/1","title":"GSMLG.Mnesia.system/1","type":"function"},{"doc":"See GSMLG.Mnesia.Transaction.execute/1 .","ref":"GSMLG.Mnesia.html#transaction/1","title":"GSMLG.Mnesia.transaction/1","type":"function"},{"doc":"See GSMLG.Mnesia.Transaction.execute!/1 .","ref":"GSMLG.Mnesia.html#transaction!/1","title":"GSMLG.Mnesia.transaction!/1","type":"function"},{"doc":"See GSMLG.Mnesia.Table.wait/1 .","ref":"GSMLG.Mnesia.html#wait/1","title":"GSMLG.Mnesia.wait/1","type":"function"},{"doc":"See GSMLG.Mnesia.Table.wait/2 .","ref":"GSMLG.Mnesia.html#wait/2","title":"GSMLG.Mnesia.wait/2","type":"function"},{"doc":"Module to read/write from GSMLG.Mnesia Tables. This module provides the most important transactional operations that can be executed on GSMLG.Mnesia Tables. Mnesia's &quot;dirty&quot; methods are left out on purpose. In almost all circumstances, these methods would be enough for interacting with GSMLG.Mnesia Tables, but for very special situations, it is better to directly use the API provided by the Erlang :mnesia module. Transaction Only All the methods exported by this module can only be executed within the context of a GSMLG.Mnesia.Transaction . Outside the transaction (synchronous or not), these methods will raise an error, even though they will be ignored in all examples moving forward. # Will raise an error GSMLG.Mnesia.Query . read ( Blog.Post , :some_id ) # Will work fine GSMLG.Mnesia . transaction fn -&gt; GSMLG.Mnesia.Query . read ( Blog.Post , :some_id ) end Basic Operations # Get all records in a Table GSMLG.Mnesia.Query . all ( User ) # Get a specific record by its primary key GSMLG.Mnesia.Query . read ( User , id ) # Write a record GSMLG.Mnesia.Query . write ( % User { id : 3 , name : &quot;Some User&quot; } ) # Delete a record by primary key GSMLG.Mnesia.Query . delete ( User , id ) # Delete a record by passing the full object GSMLG.Mnesia.Query . delete_record ( % User { id : 4 , name : &quot;Another User&quot; } ) Complex Queries GSMLG.Mnesia provides 3 ways of querying records based on some passed conditions: match/3 select/3 select_raw/3 Each method uses a different way of querying records, which is explained in detail for each of them in their method docs. But the recommended method of performing queries is using the select/3 method, which makes working with Erlang MatchSpec a lot easier. # Get all Movies GSMLG.Mnesia.Query . select ( Movie , [ ] ) # Get all Movies named &quot;Rush&quot; GSMLG.Mnesia.Query . select ( Movie , { :== , :title , &quot;Rush&quot; } ) # Get all Movies directed by Tarantino before the year 2000 guards = [ { :== , :director , &quot;Quentin Tarantino&quot; } , { :&lt; , :year , 2000 } , ] GSMLG.Mnesia.Query . select ( Movie , guards )","ref":"GSMLG.Mnesia.Query.html","title":"GSMLG.Mnesia.Query","type":"module"},{"doc":"Returns all records of a Table. This is equivalent to calling match/3 with the catch-all pattern. This also accepts an optional lock option to acquire that kind of lock in the transaction (defaults to :read ). See lock/0 for more details about lock types. # Both are equivalent GSMLG.Mnesia.Query . all ( Movie ) GSMLG.Mnesia.Query . match ( Movie , { :_ , :_ , :_ , :_ } )","ref":"GSMLG.Mnesia.Query.html#all/2","title":"GSMLG.Mnesia.Query.all/2","type":"function"},{"doc":"Delete a Record in the given table for the specified key. This method takes a GSMLG.Mnesia.Table name and a key, and deletes all records with that key (There can be more than one for table type of bag ). Options default to [lock: :write] . If you want to delete a record, by passing the record itself as the argument, see delete_record/2 . Examples # Delete a Blog Post record with the id `10` (primary key) GSMLG.Mnesia.Query . delete ( Blog.Post , 10 )","ref":"GSMLG.Mnesia.Query.html#delete/3","title":"GSMLG.Mnesia.Query.delete/3","type":"function"},{"doc":"Delete the given GSMLG.Mnesia record object. This method accepts a GSMLG.Mnesia.Table.record/0 object and deletes that from its table. A complete record object needs to be specified for this to work. Options default to [lock: :write] . This method is especially useful in Tables of type bag where multiple records can have the same key. Also see delete/3 . Examples Consider an Email table of type bag , with two attributes; user_id and email , where user_id is the primary key. The Table contains all email addresses for a given user. # Calling `delete` will delete all emails for a `user_id`: GSMLG.Mnesia.Query . delete ( Email , user_id ) # To delete a specific record, you have to pass the entire object: email_record = % Email { user_id : 5 , email : &quot;a.specific@email.addr&quot; } GSMLG.Mnesia.Query . delete_record ( email_record )","ref":"GSMLG.Mnesia.Query.html#delete_record/2","title":"GSMLG.Mnesia.Query.delete_record/2","type":"function"},{"doc":"Returns all records in a table that match the specified pattern. This method takes the name of a GSMLG.Mnesia.Table and a tuple pattern representing the values of those attributes, and returns all records that match it. It uses :_ to represent attributes that should be ignored. The tuple passed should be of the same length as the number of attributes in that table, otherwise it will throw an exception. It's recommended to use the select/3 method as it is more user-friendly, can let you make complex selections. Also accepts an optional argument :lock to acquire the kind of lock specified in that transaction (defaults to :read ). See lock/0 for more details. Also see :mnesia.match_object/3 . Examples Suppose a Movie Table with these attributes: id , title , year , and director . So the tuple passed in the match query should have 4 elements. # Get all movies from the Table GSMLG.Mnesia.Query . match ( Movie , { :_ , :_ , :_ , :_ } ) # Get all movies named &#39;Rush&#39;, with a write lock on the item GSMLG.Mnesia.Query . match ( Movie , { :_ , &quot;Rush&quot; , :_ , :_ } , lock : :write ) # Get all movies directed by Tarantino GSMLG.Mnesia.Query . match ( Movie , { :_ , :_ , :_ , &quot;Quentin Tarantino&quot; } ) # Get all movies directed by Spielberg, in the year 1993 GSMLG.Mnesia.Query . match ( Movie , { :_ , :_ , 1993 , &quot;Steven Spielberg&quot; } ) # Will raise exceptions GSMLG.Mnesia.Query . match ( Movie , { :_ , :_ } ) GSMLG.Mnesia.Query . match ( Movie , { :_ , :_ , :_ } ) GSMLG.Mnesia.Query . match ( Movie , { :_ , :_ , :_ , :_ , :_ } )","ref":"GSMLG.Mnesia.Query.html#match/3","title":"GSMLG.Mnesia.Query.match/3","type":"function"},{"doc":"Finds the GSMLG.Mnesia record for the given id in the specified table. If no record is found, nil is returned. You can also pass an optional keyword list as the 3rd argument. The only option currently supported is :lock , which acquires a lock of specified type on the operation (defaults to :read ). See lock/0 for more details. This method works a bit differently from the original :mnesia.read/3 when the table type is :bag . Since a bag can have many records with the same key, this returns only the first one. If you want to fetch all records with the given key, use match/3 or select/3 . Example GSMLG.Mnesia.Query . read ( Blog.Post , 1 ) # =&gt; %Blog.Post{id: 1, ... } GSMLG.Mnesia.Query . read ( Blog.Post , 2 , lock : :write ) # =&gt; %Blog.Post{id: 2, ... } GSMLG.Mnesia.Query . read ( Blog.Post , :unknown_id ) # =&gt; nil","ref":"GSMLG.Mnesia.Query.html#read/3","title":"GSMLG.Mnesia.Query.read/3","type":"function"},{"doc":"Return all records matching the given query. This method takes a table name, and a simplified version of the Erlang MatchSpec consisting of one or more guards . Each guard is of the form {function, argument_1, argument_2} , where the arguments can be the Table fields, literals or other nested guard functions. Guard Spec Simple Operator Functions: :== - Equality :=== - Strict Equality (For Numbers) :!= - Inequality :!== - Strict Inequality (For Numbers) :&lt; - Less than :&lt;= - Less than or equal to :&gt; - Greater than :&gt;= - Greater than or equal to Guard Functions that take nested arguments: :or :and :xor Options This method also takes some optional arguments mentioned below. See options/0 for more details. lock (defaults to :read ) limit (defaults to nil , meaning return all) coerce (defaults to true ) Examples Suppose a Movie Table with these attributes: id , title , year , and director . # Get all Movies GSMLG.Mnesia.Query . select ( Movie , [ ] ) # Get all Movies named &quot;Rush&quot; GSMLG.Mnesia.Query . select ( Movie , { :== , :title , &quot;Rush&quot; } ) # Get all Movies directed by Tarantino before the year 2000 # Note: We could use a nested `and` function here as well guards = [ { :== , :director , &quot;Quentin Tarantino&quot; } , { :&lt; , :year , 2000 } , ] GSMLG.Mnesia.Query . select ( Movie , guards ) # Get all movies directed by Tarantino or Spielberg, in 2010 or later: guards = { :and { :&gt;= , :year , 2010 } , { :or , { :== , :director , &quot;Quentin Tarantino&quot; } , { :== , :director , &quot;Steven Spielberg&quot; } , } } GSMLG.Mnesia.Query . select ( Movie , guards )","ref":"GSMLG.Mnesia.Query.html#select/3","title":"GSMLG.Mnesia.Query.select/3","type":"function"},{"doc":"Returns all records in the given table according to the full Erlang match_spec . This method accepts a pure Erlang match_spec term as described below, which can be used to write some very complex queries, but that also makes it very hard to use for beginners, and overly complex for everyday queries. It is highly recommended that you use the select/3 method which makes it much easier to write complex queries that work just as well in 99% of the cases, by making some assumptions. The arguments are directly passed on to the :mnesia.select/4 method without translating queries, as they are done in select/3 . Options See options/0 for details about these options: lock (defaults to :read ) limit (defaults to nil , meaning return all) coerce (defaults to true ) Match Spec An Erlang &quot;Match Specification&quot; or match_spec is a term describing a small program that tries to match something. This is most popularly used in both :ets and :mnesia . Quite simply, the grammar can be defined as: match_spec = [match_function, ...] (List of match functions) match_function = {match_head, [guard, ...], [result]} match_head = tuple (A tuple representing attributes to match) guard = A tuple representing conditions for selection result = Atom describing the fields to return as the result Here, the match_head describes the attributes to match (like in match/3 ). You can use literals to specify an exact value to be matched against or :&quot;$n&quot; variables ( :$1 , :$2 , ...) that can be used so they can be referenced in the guards. You can get a default value by calling YourTable.__info__().query_base . The second element in the tuple is a list of guard terms, where each guard is basically a tuple representing a condition of the form {operation, arg1, arg2} which can be simple {:==, :&quot;$2&quot;, literal} tuples or nested values like {:andalso, guard1, guard2} . Finally, result represents the fields to return. Use :&quot;$_&quot; to return all fields, :&quot;$n&quot; to return a specific field or :&quot;$$&quot; for all fields specified as variables in the match_head . Examples Suppose a Movie Table with these attributes: id , title , year , and director . So the tuple passed as the match_head should have 5 elements. Return all records: match_head = Movie . __info__ . query_base result = [ :&quot;$_&quot; ] guards = [ ] GSMLG.Mnesia.Query . select_raw ( Movie , [ { match_head , guards , result } ] ) # =&gt; [%Movie{...}, ...] Get all movies with the title &quot;Rush&quot;: # We&#39;re using the match_head pattern here, but you can also use guards match_head = { Movie , :&quot;$1&quot; , &quot;Rush&quot; , :&quot;$2&quot; , :&quot;$3&quot; } result = [ :&quot;$_&quot; ] guards = [ ] GSMLG.Mnesia.Query . select_raw ( Movie , [ { match_head , guards , result } ] ) # =&gt; [%Movie{title: &quot;Rush&quot;, ...}, ...] Get all movies title names, that were directed by Tarantino before the year 2000: # Using guards only here, but you can mix and match with head. # You can also use a nested `{:andalso, guard1, guard2}` tuple # here instead. # # We used the result value `[:&quot;$2&quot;]` so it only returns the # second (i.e. title) field. Because of this, we&#39;re also not # coercing the results. match_head = { Movie , :&quot;$1&quot; , :&quot;$2&quot; , :&quot;$3&quot; , :&quot;$4&quot; } result = [ :&quot;$2&quot; ] guards = [ { :&lt; , :&quot;$3&quot; , 2000 } , { :== , :&quot;$4&quot; , &quot;Quentin Tarantino&quot; } ] GSMLG.Mnesia.Query . select_raw ( Movie , [ { match_head , guards , result } ] , coerce : false ) # =&gt; [&quot;Reservoir Dogs&quot;, &quot;Pulp Fiction&quot;, ...] Get all movies directed by Tarantino or Spielberg, after the year 2010: match_head = { Movie , :&quot;$1&quot; , :&quot;$2&quot; , :&quot;$3&quot; , :&quot;$4&quot; } result = [ :&quot;$_&quot; ] guards = [ { :andalso , { :&gt; , :&quot;$3&quot; , 2010 } , { :orelse , { :== , :&quot;$4&quot; , &quot;Quentin Tarantino&quot; } , { :== , :&quot;$4&quot; , &quot;Steven Spielberg&quot; } , } } ] GSMLG.Mnesia.Query . select_raw ( Movie , [ { match_head , guards , result } ] , coerce : true ) # =&gt; [%Movie{...}, ...] Notes It's important to note that for customized results (not equal to :&quot;$_&quot; ), you should specify coerce: false , so it doesn't raise errors. Unlike the select/3 method, the operation values the guard tuples take in this method are Erlang atoms, not Elixir ones. For example, instead of :and &amp; :or , they will be :andalso &amp; :orelse . Similarly, you will have to use :&quot;/=&quot; instead of :!= and :&quot;=&lt;&quot; instead of :&lt;= . See the Match Specification docs, :mnesia.select/2 and :ets.select/2 more details and examples.","ref":"GSMLG.Mnesia.Query.html#select_raw/3","title":"GSMLG.Mnesia.Query.select_raw/3","type":"function"},{"doc":"Writes a GSMLG.Mnesia record to its Mnesia table. Returns the written record on success, or aborts the transaction on failure. This operatiion acquires a lock of the kind specified, which can be either :write or :sticky_write (defaults to :write ). See lock/0 and :mnesia.write/3 for more details. Autoincrement and nil primary keys This method will raise an error if the primary key of the passed GSMLG.Mnesia record is nil and the table does not have autoincrement enabled. If it is enabled, this will find the last numeric key used, increment it and assign it as the primary key of the written record (which will be returned as a result of the write operation). To enable autoincrement, the table needs to be of the type ordered_set and autoincrement: true has to be specified in the table definition. (See GSMLG.Mnesia.Table for more details). Examples GSMLG.Mnesia.Query . write ( % Blog.Post { title : &quot;something&quot; , ... } ) # =&gt; %Blog.Post{id: 4, title: &quot;something&quot;} GSMLG.Mnesia.Query . write ( % Blog.Author { username : &quot;sye&quot; , ... } ) # =&gt; %Blog.Author{username: &quot;sye&quot;, ... }","ref":"GSMLG.Mnesia.Query.html#write/2","title":"GSMLG.Mnesia.Query.write/2","type":"function"},{"doc":"Types of locks that can be acquired. There are, in total, 3 types of locks that can be aqcuired, but some operations don't support all of them. The write/2 method, for example, can only accept :write or :sticky_write locks. Conflicting lock requests are automatically queued if there is no risk of deadlock. Otherwise, the transaction must be terminated and executed again. GSMLG.Mnesia does this automatically as long as the upper limit of retries is not reached in a transaction. Types :write locks are exclusive. That means, if one transaction acquires a write lock, no other transaction can acquire any kind of lock on the same item. :read locks can be shared, meaning if one transaction has a read lock on an item, other transactions can also acquire a read lock on the same item. However, no one else can acquire a write lock on that item while the read lock is in effect. :sticky_write locks are used for optimizing write lock acquisitions, by informing other nodes which node is locked. New sticky lock requests from the same node are performed as local operations. For more details, see :mnesia.lock/2 .","ref":"GSMLG.Mnesia.Query.html#t:lock/0","title":"GSMLG.Mnesia.Query.lock/0","type":"type"},{"doc":"Option Keyword that can be passed to some methods. These are all the possible options that can be set in the given keyword list, although it mostly depends on the method which options it actually uses. Options lock - What kind of lock to acquire on the item in that transaction. This is the most common option, that almost all methods accept, and usually has some default value depending on the method. See lock/0 for more details. limit - The maximum number of items to return in a query. This is used only read queries like match/3 or select/3 , and is of the type non_neg_integer/0 . Defaults to nil , resulting in no limit and returning all records. coerce - Records in Mnesia are stored in the form of a Tuple. This converts them into simple GSMLG.Mnesia struct records of type GSMLG.Mnesia.Table.record/0 . This is equivalent to calling GSMLG.Mnesia.Query.Data.load/1 on the returned records. This option is only available to some read methods like select/3 &amp; match/3 , and its value defaults to true .","ref":"GSMLG.Mnesia.Query.html#t:options/0","title":"GSMLG.Mnesia.Query.options/0","type":"type"},{"doc":"Helper module that acts as an interface to convert GSMLG.Mnesia Table data structs into Mnesia data tuples and vice versa. This is responsible for automatically handling conversions between data in methods defined in the Query module, so you won't need to use this at all. Usage Given a GSMLG.Mnesia Table: defmodule MyApp.User do use GSMLG.Mnesia.Table , attributes : [ :id , :name ] end You can convert its structs to Mnesia format: GSMLG.Mnesia.Query.Data . dump ( % MyApp.User { id : 1 , name : &quot;Sye&quot; } ) # =&gt; {MyApp.User, 1, &quot;Sye&quot;} Or convert it back to a struct: GSMLG.Mnesia.Query.Data . load ( { MyApp.User , 2 , &quot;Rick&quot; } ) # =&gt; %MyApp.User{id: 2, name: &quot;Rick&quot;}","ref":"GSMLG.Mnesia.Query.Data.html","title":"GSMLG.Mnesia.Query.Data","type":"module"},{"doc":"Convert GSMLG.Mnesia Table struct into Mnesia data tuple. Use this method when writing data to an Mnesia database. The argument should be a struct of a previously defined GSMLG.Mnesia table definition, and this will convert it into a tuple representing an Mnesia record.","ref":"GSMLG.Mnesia.Query.Data.html#dump/1","title":"GSMLG.Mnesia.Query.Data.dump/1","type":"function"},{"doc":"Convert Mnesia data tuple into GSMLG.Mnesia Table struct. Use this method when reading data from an Mnesia database. The data should be in a tuple format, where the first element is the Table name ( GSMLG.Mnesia.Table definition). This will automatically match the the tuple values against the table's attributes and convert it into a struct of the GSMLG.Mnesia table you defined.","ref":"GSMLG.Mnesia.Query.Data.html#load/1","title":"GSMLG.Mnesia.Query.Data.load/1","type":"function"},{"doc":"Module to interact with the database schema. For persisting data, Mnesia databases need to be created on disk. This module provides an interface to create the database on the disk of the specified nodes. Most of the time that is usually the node that the application is running on. # Create schema on current node GSMLG.Mnesia.Schema . create ( [ node ( ) ] ) # Create schema on many nodes node_list = [ node ( ) , :alice@host_x , :bob@host_y , :eve@host_z ] GSMLG.Mnesia.Schema . create ( node_list ) Important thing to note here is that only the nodes where data has to be persisted to disk have to be included. RAM-only nodes should be left out. Disk schemas can also be deleted by calling delete/1 and you can get information about them by calling info/0 . Example # The nodes where you want to persist nodes = [ node ( ) ] # Create the schema GSMLG.Mnesia . stop GSMLG.Mnesia.Schema . create ( nodes ) GSMLG.Mnesia . start # Create disc copies of your tables GSMLG.Mnesia.Table . create! ( TableA , disc_copies : nodes ) GSMLG.Mnesia.Table . create! ( TableB , disc_copies : nodes )","ref":"GSMLG.Mnesia.Schema.html","title":"GSMLG.Mnesia.Schema","type":"module"},{"doc":"Creates a new database on disk on the specified nodes. Calling :mnesia.create_schema for a custom path throws an exception if that path does not exist. GSMLG.Mnesia's version avoids this by ensuring that the directory exists. Also see :mnesia.create_schema/1 .","ref":"GSMLG.Mnesia.Schema.html#create/1","title":"GSMLG.Mnesia.Schema.create/1","type":"function"},{"doc":"Deletes the database previously created by create/1 on the specified nodes. Use this with caution, as it makes persisting data obsolete. Also see :mnesia.delete_schema/1 .","ref":"GSMLG.Mnesia.Schema.html#delete/1","title":"GSMLG.Mnesia.Schema.delete/1","type":"function"},{"doc":"Prints schema information about all Tables to the console.","ref":"GSMLG.Mnesia.Schema.html#info/0","title":"GSMLG.Mnesia.Schema.info/0","type":"function"},{"doc":"Prints schema information about the specified Table to the console.","ref":"GSMLG.Mnesia.Schema.html#info/1","title":"GSMLG.Mnesia.Schema.info/1","type":"function"},{"doc":"Sets the schema storage mode for the specified node. Useful when you want to change the schema mode on the fly, usually when connecting to a new, unsynchronized node on discovery at runtime. The mode can only be :ram_copies or :disc_copies . If the storage mode is set to ram_copies , then no table on that node can be disc-resident. This just calls GSMLG.Mnesia.Table.set_storage_type/3 underneath with :schema as the table. Also see :mnesia.change_table_copy_type/3 for more details. Example GSMLG.Mnesia.Schema . set_storage_type ( :node@host , :disc_copies )","ref":"GSMLG.Mnesia.Schema.html#set_storage_type/2","title":"GSMLG.Mnesia.Schema.set_storage_type/2","type":"function"},{"doc":"Helper functions for tests","ref":"GSMLG.Mnesia.Support.html","title":"GSMLG.Mnesia.Support","type":"module"},{"doc":"See ExUnit.CaptureIO.capture_io/1 .","ref":"GSMLG.Mnesia.Support.html#capture_io/1","title":"GSMLG.Mnesia.Support.capture_io/1","type":"function"},{"doc":"See ExUnit.CaptureLog.capture_log/1 .","ref":"GSMLG.Mnesia.Support.html#capture_log/1","title":"GSMLG.Mnesia.Support.capture_log/1","type":"function"},{"doc":"Default Test Case with important aliases/imports","ref":"GSMLG.Mnesia.Support.Case.html","title":"GSMLG.Mnesia.Support.Case","type":"module"},{"doc":"","ref":"GSMLG.Mnesia.Support.Definitions.html","title":"GSMLG.Mnesia.Support.Definitions","type":"module"},{"doc":"Helper table definitions","ref":"GSMLG.Mnesia.Support.Definitions.Tables.html","title":"GSMLG.Mnesia.Support.Definitions.Tables","type":"module"},{"doc":"","ref":"GSMLG.Mnesia.Support.Definitions.Tables.Email.html","title":"GSMLG.Mnesia.Support.Definitions.Tables.Email","type":"module"},{"doc":"","ref":"GSMLG.Mnesia.Support.Definitions.Tables.Email.html#seed/0","title":"GSMLG.Mnesia.Support.Definitions.Tables.Email.seed/0","type":"function"},{"doc":"","ref":"GSMLG.Mnesia.Support.Definitions.Tables.Movie.html","title":"GSMLG.Mnesia.Support.Definitions.Tables.Movie","type":"module"},{"doc":"","ref":"GSMLG.Mnesia.Support.Definitions.Tables.Movie.html#seed/0","title":"GSMLG.Mnesia.Support.Definitions.Tables.Movie.seed/0","type":"function"},{"doc":"","ref":"GSMLG.Mnesia.Support.Definitions.Tables.Nested.html","title":"GSMLG.Mnesia.Support.Definitions.Tables.Nested","type":"module"},{"doc":"","ref":"GSMLG.Mnesia.Support.Definitions.Tables.Nested.html#seed/0","title":"GSMLG.Mnesia.Support.Definitions.Tables.Nested.seed/0","type":"function"},{"doc":"","ref":"GSMLG.Mnesia.Support.Definitions.Tables.User.html","title":"GSMLG.Mnesia.Support.Definitions.Tables.User","type":"module"},{"doc":"","ref":"GSMLG.Mnesia.Support.Definitions.Tables.User.html#seed/0","title":"GSMLG.Mnesia.Support.Definitions.Tables.User.seed/0","type":"function"},{"doc":"Mnesia-related helpers","ref":"GSMLG.Mnesia.Support.Mnesia.html","title":"GSMLG.Mnesia.Support.Mnesia","type":"module"},{"doc":"","ref":"GSMLG.Mnesia.Support.Mnesia.html#reset/0","title":"GSMLG.Mnesia.Support.Mnesia.reset/0","type":"function"},{"doc":"","ref":"GSMLG.Mnesia.Support.Mnesia.html#start/0","title":"GSMLG.Mnesia.Support.Mnesia.start/0","type":"function"},{"doc":"","ref":"GSMLG.Mnesia.Support.Mnesia.html#stop/0","title":"GSMLG.Mnesia.Support.Mnesia.stop/0","type":"function"},{"doc":"","ref":"GSMLG.Mnesia.Support.Mnesia.html#transaction/1","title":"GSMLG.Mnesia.Support.Mnesia.transaction/1","type":"function"},{"doc":"","ref":"GSMLG.Mnesia.Support.Mnesia.html#transaction!/1","title":"GSMLG.Mnesia.Support.Mnesia.transaction!/1","type":"function"},{"doc":"Defines a GSMLG.Mnesia Table schema for Mnesia Usage You can define an Mnesia Table by calling use GSMLG.Mnesia.Table with a few options in your module. defmodule Blog.Post do use GSMLG.Mnesia.Table , attributes : [ :id , :title , :content ] end Each table then must be created before you can interact with it. You can do that by calling create/2 . It's usually a good idea to call this while your application is being started: GSMLG.Mnesia.Table . create ( Blog.Post ) Options The table definition and the create/2 function both accept a keyword list specifying the options for the table: attributes - A required list of atoms representing the attribute names of the records of the table. Must have at least two attributes, where the first one is the primary key. type - One of :set , :ordered_set , or :bag . Default is :set . In a :set , all records have unique keys. In a :bag , several records can have the same key, but the record content is unique. If a non-unique record is stored, the old conflicting records are overwritten. index - List of fields to index. autoincrement - If the table is of the type :ordered_set , setting this true will automatically assign numeric values to non-nil primary keys when writing records (using GSMLG.Mnesia.Query.write/2 ). Will return an error if the table is not of the type :ordered_set . The only required option is attributes . See :mnesia.create_table/2 for a full list of options. See the following example that uses more options: defmodule Blog.Post do use GSMLG.Mnesia.Table , attributes : [ :id , :title , :content , :status , :author_id ] , index : [ :status , :author_id ] , type : :ordered_set , autoincrement : true # You can also define other methods # or helper functions in the module end","ref":"GSMLG.Mnesia.Table.html","title":"GSMLG.Mnesia.Table","type":"behaviour"},{"doc":"Returns Table definition information. Every defined GSMLG.Mnesia.Table via the use macro, will export this method, returning information about its attributes, structure, options and other details.","ref":"GSMLG.Mnesia.Table.html#c:__info__/0","title":"GSMLG.Mnesia.Table.__info__/0","type":"callback"},{"doc":"Deletes all entries in the given GSMLG.Mnesia Table. Returns :ok on success and {:error, reason} on failure.","ref":"GSMLG.Mnesia.Table.html#clear/1","title":"GSMLG.Mnesia.Table.clear/1","type":"function"},{"doc":"Creates a GSMLG.Mnesia Table for Mnesia. This must be called before you can interact with the table in any way. Uses the attributes specified in the table definition. Returns :ok on success or {:error, reason} on failure. Will raise an error if the passed module isn't a GSMLG.Mnesia Table. You can optionally pass a set of options keyword, which will override all options specified in the definition except :attributes . See :mnesia.create_table/2 for all available options.","ref":"GSMLG.Mnesia.Table.html#create/2","title":"GSMLG.Mnesia.Table.create/2","type":"function"},{"doc":"Same as create/2 , but raises error on failure.","ref":"GSMLG.Mnesia.Table.html#create!/2","title":"GSMLG.Mnesia.Table.create!/2","type":"function"},{"doc":"Makes a copy of a table at the given node. Especially useful when you want to replicate a table on another node on the fly, usually when connecting to it the first time. The argument type must be a valid storage_type() atom. This can also be used to create a replica of the internal :schema table. Also see :mnesia.add_table_copy/3 . Example # Create an on-disc replica of `Users` table on another node GSMLG.Mnesia.Table . create_copy ( Users , :some_node@host_x , :disc_copies )","ref":"GSMLG.Mnesia.Table.html#create_copy/3","title":"GSMLG.Mnesia.Table.create_copy/3","type":"function"},{"doc":"Deletes a GSMLG.Mnesia Table for Mnesia. Returns :ok on success and {:error, reason} on failure.","ref":"GSMLG.Mnesia.Table.html#delete/1","title":"GSMLG.Mnesia.Table.delete/1","type":"function"},{"doc":"Same as delete/1 , but raises error on failure.","ref":"GSMLG.Mnesia.Table.html#delete!/1","title":"GSMLG.Mnesia.Table.delete!/1","type":"function"},{"doc":"Deletes the replica of a table on the specified node. When the last replica of a table is deleted, the table disappears entirely. This function can also be used to delete the replica of the internal :schema table which will cause the Mnesia node to be removed (Mnesia/GSMLG.Mnesia must be stopped first). Also see :mnesia.del_table_copy/2 .","ref":"GSMLG.Mnesia.Table.html#delete_copy/2","title":"GSMLG.Mnesia.Table.delete_copy/2","type":"function"},{"doc":"Returns all table information. Optionally accepts an extra atom argument key which returns result for only that key. Will throw an exception if the key is invalid. See :mnesia.table_info/2 for a full list of allowed keys.","ref":"GSMLG.Mnesia.Table.html#info/2","title":"GSMLG.Mnesia.Table.info/2","type":"function"},{"doc":"Moves a table's copy from one node to the other. This operation preserves the storage type of the table. For example, a :ram_copies table when moved from one node, remains keeps its :ram_copies storage type on the new node. Other transactions can still read and write while it's being moved. This function cannot be called on the internal :local_content tables. Also see :mnesia.move_table_copy/3 .","ref":"GSMLG.Mnesia.Table.html#move_copy/3","title":"GSMLG.Mnesia.Table.move_copy/3","type":"function"},{"doc":"Sets the storage type of a table for the specified node. Useful when you want to change the table's copy type on the fly, usually when connecting to a new, unsynchronized node on discovery at runtime. The argument type must be a valid storage_type() atom. This can also be used for the internal :schema table, but you should use GSMLG.Mnesia.Schema.set_storage_type/2 instead. See :mnesia.change_table_copy_type/3 for more details. Example GSMLG.Mnesia.Table . set_storage_type ( MyTable , :node@host , :disc_copies )","ref":"GSMLG.Mnesia.Table.html#set_storage_type/3","title":"GSMLG.Mnesia.Table.set_storage_type/3","type":"function"},{"doc":"Transform Table schema For more information, see :mnesia.transform_table/3 . Examples # Transform table&#39;s schema, add attribute `imdb` GSMLG.Mnesia.Table . transform ( Movies , fn ( { Movies , id , name , year } ) -&gt; { Movies , id , name , year , nil } end , [ :id , :name , :year , :imdb ] )","ref":"GSMLG.Mnesia.Table.html#transform/3","title":"GSMLG.Mnesia.Table.transform/3","type":"function"},{"doc":"Wait until specified tables are ready. Before performing some tasks, it's necessary that certain tables are ready and accessible. This call hangs until all tables specified are accessible, or until timeout is reached (default: 3000ms). The timeout value can either be :infinity or an integer representing time in milliseconds. If you pass a Table/Module that does not exist along with :infinity as timeout, it will hang your process until that table is created and ready. This method can be accessed directly on the GSMLG.Mnesia module as well. For more information, see :mnesia.wait_for_tables/2 . Examples # Wait until the `Movies` table is ready GSMLG.Mnesia.Table . wait ( Movies , :infinity ) # Wait a maximum of 3 seconds until the two tables are ready GSMLG.Mnesia . wait ( [ TableA , TableB ] )","ref":"GSMLG.Mnesia.Table.html#wait/2","title":"GSMLG.Mnesia.Table.wait/2","type":"function"},{"doc":"A GSMLG.Mnesia.Table module","ref":"GSMLG.Mnesia.Table.html#t:name/0","title":"GSMLG.Mnesia.Table.name/0","type":"type"},{"doc":"A GSMLG.Mnesia.Table record data struct","ref":"GSMLG.Mnesia.Table.html#t:record/0","title":"GSMLG.Mnesia.Table.record/0","type":"type"},{"doc":"Table storage/copy type","ref":"GSMLG.Mnesia.Table.html#t:storage_type/0","title":"GSMLG.Mnesia.Table.storage_type/0","type":"type"},{"doc":"GSMLG.Mnesia's wrapper around Mnesia transactions. This module exports methods execute/2 and execute_sync/2 , and their bang versions, which accept a function to be executed and an optional argument to set the maximum no. of retries until the transaction succeeds. execute/1 and execute!/1 can be directly called from the base GSMLG.Mnesia module as the alias GSMLG.Mnesia.transaction/1 and GSMLG.Mnesia.transaction!/1 methods, but if you want to specify a custom retries value or use the synchronous version, you should use the methods in this module. Examples # Read a User record { :ok , user } = GSMLG.Mnesia . transaction fn -&gt; GSMLG.Mnesia.Query . read ( User , id ) end # Get all Users, raising errors on aborts users = GSMLG.Mnesia . transaction! fn -&gt; GSMLG.Mnesia.Query . all ( User ) end # Update a User record on all nodes synchronously, # with a maximum of 5 retries operation = fn -&gt; GSMLG.Mnesia.Query . write ( % User { id : 3 , name : &quot;New Value&quot; } ) end GSMLG.Mnesia.Transaction . execute_sync ( operation , 5 )","ref":"GSMLG.Mnesia.Transaction.html","title":"GSMLG.Mnesia.Transaction","type":"module"},{"doc":"Aborts a GSMLG.Mnesia transaction. Causes the transaction to return an error tuple with the passed argument: {:error, {:transaction_aborted, reason}} . Outside the context of a transaction, simply raises an error. In the bang versions of the transactions, it raises a GSMLG.Mnesia.TransactionAborted error instead of returning the error tuple. Default value for reason is :no_reason_given .","ref":"GSMLG.Mnesia.Transaction.html#abort/1","title":"GSMLG.Mnesia.Transaction.abort/1","type":"function"},{"doc":"Execute passed function as part of an Mnesia transaction. Default value of retries is :infinity . Returns either {:ok, result} or {:error, reason} . Also see :mnesia.transaction/2 .","ref":"GSMLG.Mnesia.Transaction.html#execute/2","title":"GSMLG.Mnesia.Transaction.execute/2","type":"function"},{"doc":"Same as execute/2 but returns the result or raises an error.","ref":"GSMLG.Mnesia.Transaction.html#execute!/2","title":"GSMLG.Mnesia.Transaction.execute!/2","type":"function"},{"doc":"Execute the transaction in synchronization with all nodes. This method waits until the data has been committed and logged to disk (if used) on all involved nodes before it finishes. This is useful to ensure that a transaction process does not overload the databases on other nodes. Returns either {:ok, result} or {:error, reason} . Also see :mnesia.sync_transaction/2 .","ref":"GSMLG.Mnesia.Transaction.html#execute_sync/2","title":"GSMLG.Mnesia.Transaction.execute_sync/2","type":"function"},{"doc":"Same as execute_sync/2 but returns the result or raises an error.","ref":"GSMLG.Mnesia.Transaction.html#execute_sync!/2","title":"GSMLG.Mnesia.Transaction.execute_sync!/2","type":"function"},{"doc":"Checks if you are inside a transaction.","ref":"GSMLG.Mnesia.Transaction.html#inside?/0","title":"GSMLG.Mnesia.Transaction.inside?/0","type":"function"},{"doc":"Maximum no. of retries for a transaction","ref":"GSMLG.Mnesia.Transaction.html#t:retries/0","title":"GSMLG.Mnesia.Transaction.retries/0","type":"type"}]